clear all;
load PieceRegSig;
load Daub4;
h
g
rh
rg
e = conv(sig,h);
w = conv(sig,g);
e = e(1:2:length(e));
w = w(1:2:length(w));
figure(1);
plot(sig);
figure(2);
plot(e);
figure(3);
plot(w);
echo on;
% On observe des valeurs elevees aux bords alors que le signal d'origine
% y est lisse. C'est parce qu'on fait une analyse par une ondelette adaptee
% aux signaux de longueur infinie, et non aux signaux de longueur finie.
% La dcomposition effectuee est en fait celle d'un signal infini dont
% la restriction a [0,1023] est sig, et nul en dehors. 
% Ce signal est discontinu en 0 et en 1023;
% il est normal qu'il provoque de grands coefficients d'ondlettes au
% voisinage de ces points. De meme, le signal e reflete les sauts entre 0 et 
% les valeurs au bord de sig.
%
% h est le miroir du filtre de Daubechies (ici, rh); son support est [-3,0].
% En effet, le miroir F d'un filtre f est defini par F(n) = f(-n).
%
% Le support de sig est [0,1023].
% Le support de h est [-3,0]; de meme, le support de g est [-3,0].
% Les convolutions definissant e et w s'ecrivent donc:
% Y[n] = F[-3]*SIG[n+3] + F[-2]*SIG[n+2] + F[-1]*SIG[n+1]+ F[0]*SIG[n],
% ou F est le filtre et Y la sortie.
% Y[n] est donc nul pour n>1023 ou n+3<0; le support de Y est donc
% [-3,1023] et la premiere valeur correspond a l'instant -3.
% Si on utilise la representation polynomiale (transformee en z),
% F est de valuation -3 et de degre 0; SIG est de valuation 0 et de degre 1023.
% Leur produit est donc de valuation -3+0 = -3 et de degre 0+1023 = 1023
% et on retrouve le support.
echo off
