clear all;
load PieceRegSig;
load Daub4;
h
g
rh
rg
e = conv(sig,h);
w = conv(sig,g);
e = e(1:2:length(e));
w = w(1:2:length(w));
figure(1);
plot(sig);
figure(2);
plot(e);
figure(3);
plot(w);
n = length(e);
e1 = zeros(1,2*n-1);
w1 = e1;
e1(1:2:length(e1)) = e; % insertion de zeros
w1(1:2:length(e1)) = w;
e1 = conv(e1,rh); % convolution avec les filtres de reconstruction
w1 = conv(w1,rg);
sig1 = e1 + w1;
echo on;
% Avant sous-echantillonnage, E et W ont pour support [-3,1023];
% l'insertion de zeros apres le sous echantillonnage ne change pas le support
% (cela revient a remplacer une valeur sur deux par un zero),
% et donc E1 et W1 ont comme support [-3,1023].
% Les filtres H et RH sont de support [0,3]. La convolution de X avec RH s'ecrit:
% Y[n] = RH[0]*X[n] + RH[1]*X[n-1] + RH[2]*X[n-2]+ RH[3]*X[n-3].
% Y est nul si n-3>1023 ou n<-3; le support de Y est donc [-3,1026].
% Pour recuperer sig, il faut eliminer trois valeurs a gauche et trois valeurs
% a droite:
echo off;
sig2 = sig1(4:length(sig1)-3);
figure(4);
plot(sig-sig2);
figure(5);
plot(sig-sig1(3:length(sig1)-4));
echo on;
% L'erreur de reconstruction est de l'ordre d 10e-14, ce qui est tout
% a fait satisfaisant.
% Le trace en figure 5 represente la diffrence entre un signal et son translate
% de 1. C'est le resultat d'une difference finie sur le signal. Il prend donc de
% grandes valeurs la ou le signal a des singularites.
%
% Le trace de la figure 5 est une suite de differences finies. Il represente donc
% une approximation de la derivee de sig pour un pas de temps de 1. 
% Ces differences finies coincident, a un facteur multiplicatif pres, avec le
% signal wc non sous echantillonne dans la base de Haar. Comme l'ondelette de Haar
% n'a qu'un moment nul, elle est surtout sensible a la vitesse (ce qui est normal
% puisqu'on effectue des differences finies).
% L'ondelette de Daubechies utilisee a 2 moments nuls; elle n'est donc sensible
% qu'a l'acceleration, ce qui explique le trace plus plat des coefficients d'ondelettes
% dans le figure 3 en dehors des singularites.
% C'est une illustration de l'importante capitale du nombre de moments nuls dans
% l'utilisation de la transformee en ondelettes.
echo off;
