clear all;
load 'PieceRegSig';
load 'Daub4';
[e,w1,start1] = decomp(sig,h,g,0);
% On calcule les supports.
% Le support de sig est [0,1023] et le support des filtres orthogonaux
% h et g est [-3,0]
% le support de w1 est [-3,1023] avant sous-echantillonnage.
% Apres sous-echantilonnage, son support est [-2:2:1022]
% Sa longueur est 511+1+1=513.
length(w1) % doit etre 513
start1 % doit etre -1

[e,w2,start2] = decomp(e,h,g,start1);
% Avant sous-echantillonnage, le support de w2 est [-2-6:2:1022]=[-8:2:1022].
% Apres sous-echantilonnage, son support est [-8:4:1020]
% Sa longueur est 255+2+1=258.
length(w2) % doit etre 258
start2 % doit etre -2

[e,w3,start3] = decomp(e,h,g,start2);
% Avant sous-echantillonnage, le support de w3 est [-8-4*3:4:1020]=[-20:4:1020].
% Apres sous-echantilonnage, son support est [-16:8:1016].
% Sa longueur est 127+2+1=130.
length(w3) % doit etre 130
start3 % doit etre -2

[e,w4,start4] = decomp(e,h,g,start3);
% Avant sous-echantillonnage, les supports de e et w4 sont [-16-8*3:8:1016]=[-40:8:1016]
% Apres sous-echantilonnage, son support est [-32:16:1008].
% Sa longueur est 63+2+1=66
length(w4) % doit etre 66
start4 % doit etre -2

figure(1)
plot5(e,w4,w3,w2,w1);
