clear all;
load 'PieceRegSig';
load 'Daub4';
[e,w1,start1] = decomp(sig,h,g,0);
% le support de w1 est [-2:2:1022]
% Sa longueur est 511+1+1=513.
[e,w2,start2] = decomp(e,h,g,start1);
% le support de w2 est [-8:4:1020]
[e,w3,start3] = decomp(e,h,g,start2);
% le support de w3 est [-16:8:1016].
[e,w4,start4] = decomp(e,h,g,start3);
% les supports de e et w4 sont [-32:16:1008].
figure(3)
plot5(e,sort(abs(w4)),sort(abs(w3)),sort(abs(w2)),sort(abs(w1)));
% selection des plus grands lments
l = length(e);
n = floor(130-l)/4; % on garde le meme nombre de donnees
w4 = greatest(w4,n);
w3 = greatest(w3,n);
w2 = greatest(w2,n);
w1 = greatest(w1,n);
figure(4)
plot5(e,w4,w3,w2,w1);

% reconstruction
e = recons(e,w4,rh,rg);
% A la reconstruction, le support de e est
% [-32:8:1008+3*8] = [-32:8:1032]; sa longueur est 129+4+1=134.
% Il faut completer w3 pour le synchroniser
w3 =[zeros(1,2) w3 zeros(1,2)];
e = recons(e,w3,rh,rg);
% A la reconstruction, le support de e est
% [-32:4:1032+3*4] = [-32:4:1044]; sa longueur est 261+8+1=270.
% Il faut completer w2 pour le synchroniser
% 6 = (32-8)/4 = (1044-1008)/4
w2 =[zeros(1,6) w2 zeros(1,6)];
e = recons(e,w2,rh,rg);
% A la reconstruction, le support de e est
% [-32:2:1044+3*2] = [-32:2:1050]; sa longueur est 525+16+1=542.
% Il faut completer w1 pour le synchroniser
% 15 = (32-2)/2 et (1050-1022)/2 = 14
w1 =[zeros(1,15) w1 zeros(1,14)];
e = recons(e,w1,rh,rg);
% A la reconstruction, le support de e est
% [-32:1050+3] = [-32:1053]; sa longueur est 1053+32+1=1086.
sig1 = e(33:33+1023);
figure(1)
plot(sig1)
d = sig1-sig;
figure(2)
plot(d)
(d*d')/length(d)
% nombre de coefficients utiliss
l+4*n
%
% Le tri peut etre rendu plus efficace en faisant un tri global 
% sur l'ensemble des coefficients d'ondelettes, et non plus
% echelle par echelle. Mais cela demande un peu plus de programmation!
% On peut galement amliorer l'approximation e en utilisant une
% ondelette avec plus de moments nuls.
