function [y,start] = subfilt(sig,h,start)
% y = subfilt(sig,h,start) convolves the signal sig with the filter h of support
% [-length(h)+1,0], and subsamples it by keeping the value at 0.
% At the input, start is the first index in the support of sig;
% at the output, start is the first index in the support of y,
% using the new time step.
y = conv(sig,h);
n = length(h)-1;
start = start-n; % present y has a support which begins at start-n.
y = y(isodd(start)+1:2:length(y)); % start at 1 if n is even, else at 2
start = start + isodd(start); % add 1 to start if it is odd
start = start/2; % subsampling divides start by 2
